## stopt 5.12+dfsg

=== CMakeLists.txt ===
# vim: set sw=2 ts=2 sts=2:
CMAKE_MINIMUM_REQUIRED(VERSION 3.18)

set(VERSION_REGEX "#define STOPT_VERSION")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/StOpt/core/utils/version.h" VERSION_STRING REGEX ${VERSION_REGEX})
string(REGEX REPLACE ${VERSION_REGEX} "" VERSION_STRING "${VERSION_STRING}")
string(REGEX REPLACE " *\"" "" VERSION_STRING "${VERSION_STRING}")
MESSAGE(STATUS "StOpt version : ${VERSION_STRING}")
PROJECT(LIBRARY_STOPT  VERSION ${VERSION_STRING} LANGUAGES CXX)
SET(CMAKE_MODULE_PATH "${LIBRARY_STOPT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")
SET(CMAKE_MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

IF(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# option for PYTHON
OPTION(BUILD_PYTHON "Build python bindings" ON)

# option for MPI
OPTION(BUILD_MPI "Build MPI test" ON)

# option for SDDP 
OPTION(BUILD_SDDP "Build SDDP test" OFF)

# option for DP for Cuts
OPTION(BUILD_DPCUTS "Build DP CUTS test" OFF)

OPTION(BUILD_CPACK "Build for CPACK" OFF)

# option for branching
OPTION(BUILD_BRANCHING "Build Branching test" OFF)
IF (BUILD_BRANCHING)
  IF (NOT BUILD_MPI)
    MESSAGE(FATAL_ERROR "MPI should be on for Branching")
  ENDIF()
  FIND_PACKAGE(Trng4 REQUIRED)
  INCLUDE_DIRECTORIES(SYSTEM ${TRNG4_INCLUDE_DIRS})
ENDIF()

#option for building test
OPTION(BUILD_TEST "Build test " ON)

#option for testing long test cases
OPTION(BUILD_LONG_TEST "Add long tests to the testing module" OFF)
IF(BUILD_LONG_TEST)
  ADD_DEFINITIONS(-DUSE_LONG_TEST)
ENDIF(BUILD_LONG_TEST)

# Boost
ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
IF(BUILD_TEST)
  FIND_PACKAGE(Boost COMPONENTS unit_test_framework  system  timer chrono log thread  REQUIRED)
ENDIF()
MESSAGE(STATUS "Boost unit_test_framework: ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}")
FIND_PACKAGE(Boost COMPONENTS  random REQUIRED)
find_package (Threads REQUIRED)
FIND_PACKAGE(Boost COMPONENTS serialization REQUIRED)
MESSAGE(STATUS "Boost serialization : ${Boost_SERIALIZATION_LIBRARY}")
INCLUDE_DIRECTORIES(SYSTEM ${Boost_INCLUDE_DIRS})
IF(BUILD_MPI)
  FIND_PACKAGE(MPI)
  IF(NOT MPI_CXX_FOUND)
    SET(BUILD_MPI OFF)
  ELSE()
    FIND_PACKAGE(Boost COMPONENTS mpi )
    IF(Boost_MPI_FOUND)
      MESSAGE(STATUS "Boost mpi: ${Boost_MPI_LIBRARY}")
    ENDIF(Boost_MPI_FOUND)
    IF(Boost_MPI_FOUND)
      INCLUDE_DIRECTORIES(SYSTEM ${MPI_CXX_INCLUDE_PATH})
      ADD_DEFINITIONS(-DUSE_MPI)
    ELSE()
      MESSAGE(STATUS "Boost modules mpi  not found. Set BUILD_MPI=OFF")
      SET(BUILD_MPI OFF)
    ENDIF(Boost_MPI_FOUND)
  ENDIF(NOT MPI_CXX_FOUND)
ENDIF(BUILD_MPI)

IF (WIN32)
  #zlib
  FIND_PACKAGE(ZLIB REQUIRED)
 
  #bzip2
  FIND_PACKAGE(BZip2 REQUIRED)
ENDIF(WIN32)

#Eigen
FIND_PACKAGE(Eigen3 REQUIRED)
INCLUDE_DIRECTORIES(SYSTEM ${EIGEN3_INCLUDE_DIR})
# Add some extra delete[] and new[] operatros needed by boost to Eigen::PlainObjectBase
IF (APPLE)
  ADD_DEFINITIONS(-DEIGEN_PLAINOBJECTBASE_PLUGIN="StOpt/core/utils/eigenMemory.h")
ENDIF(APPLE)


INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR})

IF (NOT MSVC)
 # Detect if the compiler supports C+11
 INCLUDE(CheckCXXCompilerFlag)
 CHECK_CXX_COMPILER_FLAG("-std=c++14" COMPILER_SUPPORTS_CXX14)
 CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
 CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
 IF(COMPILER_SUPPORTS_CXX14)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
 ELSEIF(COMPILER_SUPPORTS_CXX11)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
 ELSEIF(COMPILER_SUPPORTS_CXX0X)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
 ELSE()
  MESSAGE(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
 ENDIF()
 SET(PTHREAD_LIBRARY "-lpthread")
ELSE()
  IF(MSVC_VERSION LESS 1800)
    MESSAGE(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no decent C++11 support. Please use a different C++ compiler.")
  ENDIF()
  ADD_COMPILE_OPTIONS(/bigobj)
ENDIF(NOT MSVC)

# Update flags according to the compiler
IF (${CMAKE_CXX_COMPILER_ID} MATCHES Clang)
   IF (APPLE)
     SET(CLANG_SANITIZE_FLAGS "")
  ELSE(APPLE)
     #SET(CLANG_SANITIZE_FLAGS " -fsanitize=undefined-trap,memory -fsanitize-memory-track-origins  -fno-omit-frame-pointer ")
     #SET(CLANG_SANITIZE_FLAGS " -fsanitize=undefined-trap  -fno-omit-frame-pointer ")
     SET(CLANG_SANITIZE_FLAGS "")
  ENDIF(APPLE)
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}  -g -O0 ${CLANG_SANITIZE_FLAGS}")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fPIC -O3 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -fPIC -O2 -DNDEBUG -g  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra -Wfloat-equal -Wno-system-headers ")
ELSEIF (${CMAKE_CXX_COMPILER_ID} MATCHES GNU)
  IF (APPLE)
    SET(GCC_SANITIZE_FLAGS "")
  ELSE(APPLE)
    SET(GCC_SANITIZE_FLAGS "")
  ENDIF(APPLE)
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}  -g -O0 ")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-long-long -Winit-self -Wfloat-equal -Wsign-compare -pedantic -funroll-all-loops -ffast-math -fno-strict-aliasing -ftree-vectorize  -fPIC")
ELSEIF(${CMAKE_CXX_COMPILER_ID} MATCHES Intel)
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fpic -O1 -g -ftrapuv")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fpic -O3 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -fpic -O2 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
ENDIF()

# Find OpenMP
FIND_PACKAGE(OpenMP)


# SERIALIZATION WITH RANDOM ACCESS
ADD_SUBDIRECTORY(geners-1.11.0)
SET(GENERS_LIB  geners)
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/geners-1.11.0)


# Compile library for C++
INCLUDE_DIRECTORIES(SYSTEM ${PROJECT_SOURCE_DIR} ${Boost_INCLUDE_DIRS})
SET(SOURCE_DIR_LIB1 ${PROJECT_SOURCE_DIR}/StOpt/regression)
SET(SOURCE_DIR_LIB2 ${PROJECT_SOURCE_DIR}/StOpt/core/utils)
SET(SOURCE_DIR_LIB3 ${PROJECT_SOURCE_DIR}/StOpt/sddp)
SET(SOURCE_DIR_LIB4 ${PROJECT_SOURCE_DIR}/StOpt/core/sparse)
SET(SOURCE_DIR_LIB5 ${PROJECT_SOURCE_DIR}/StOpt/core/grids)
SET(SOURCE_DIR_LIB6 ${PROJECT_SOURCE_DIR}/StOpt/semilagrangien)
SET(SOURCE_DIR_LIB7 ${PROJECT_SOURCE_DIR}/StOpt/dp)
SET(SOURCE_DIR_LIB8 ${PROJECT_SOURCE_DIR}/StOpt/core/parallelism)
SET(SOURCE_DIR_LIB9 ${PROJECT_SOURCE_DIR}/StOpt/tree)
SET(SOURCE_DIR_LIB10 ${PROJECT_SOURCE_DIR}/StOpt/cdf)
FILE(GLOB SOURCE  ${SOURCE_DIR_LIB1}/*.cpp ${SOURCE_DIR_LIB2}/*.cpp  ${SOURCE_DIR_LIB3}/*.cpp  ${SOURCE_DIR_LIB4}/*.cpp   ${SOURCE_DIR_LIB5}/*.cpp  ${SOURCE_DIR_LIB6}/*.cpp ${SOURCE_DIR_LIB7}/*.cpp  ${SOURCE_DIR_LIB8}/*.cpp ${SOURCE_DIR_LIB9}/*.cpp ${SOURCE_DIR_LIB10}/*.cpp  )
IF (WIN32)
  SET(SUFF "/Release")
  SET(EXTENSION ".exe")
  ADD_LIBRARY(StOpt STATIC ${SOURCE})
ELSE()
   ADD_LIBRARY(StOpt SHARED ${SOURCE})
ENDIF()
IF(BUILD_MPI)
  TARGET_LINK_LIBRARIES(StOpt ${MPI_CXX_LIBRARIES} ${MPI_C_LIBRARIES}    ${Boost_CHRONO_LIBRARY}  ${Boost_SYSTEM_LIBRARY} ${Boost_TIMER_LIBRARY}  ${Boost_MPI_LIBRARY}  ${Boost_SERIALIZATION_LIBRARY} ${GENERS_LIB} ${Boost_RANDOM_LIBRARY}  ${Boost_LOG_LIBRARY}  ${BZIP2_LIBRARIES}  ${ZLIB_LIBRARIES})
ELSE()
  TARGET_LINK_LIBRARIES(StOpt     ${Boost_CHRONO_LIBRARY}  ${Boost_SYSTEM_LIBRARY} ${Boost_TIMER_LIBRARY}  ${Boost_SERIALIZATION_LIBRARY} ${GENERS_LIB} ${Boost_RANDOM_LIBRARY} ${Boost_LOG_LIBRARY} ${BZIP2_LIBRARIES}  ${ZLIB_LIBRARIES} )
ENDIF()
IF(OPENMP_CXX_FOUND)
   TARGET_LINK_LIBRARIES(StOpt OpenMP::OpenMP_CXX)
ENDIF(OPENMP_CXX_FOUND)
SET (STOPT_LIB StOpt)
#install lib
INSTALL(TARGETS StOpt COMPONENT libraries DESTINATION "lib")
# install headers
INSTALL(DIRECTORY StOpt
    COMPONENT headers
    DESTINATION "include"
    FILES_MATCHING
    PATTERN "*.h"
    ${INSTALL_PERMISSIONS_SRC}
  )


INSTALL(DIRECTORY doc
    DESTINATION "doc"
    FILES_MATCHING
    PATTERN "*.pdf"
    ${INSTALL_PERMISSIONS_SRC}
    )

IF(BUILD_PYTHON)
    
  # Python
  FIND_PACKAGE(Python REQUIRED COMPONENTS Interpreter Development NumPy)
  INCLUDE_DIRECTORIES(SYSTEM ${Python_INCLUDE_DIRS})
  MESSAGE(STATUS "Python: ${Python_INCLUDE_DIRS}")

  # find pybind
  find_package(PyBind11 REQUIRED)

  # Numpy
  INCLUDE_DIRECTORIES(SYSTEM ${Python3_NumPy_INCLUDE_DIRS})
  SET(SOURCE_PYTHON ${PROJECT_SOURCE_DIR}/StOpt/python)
  IF(CMAKE_SYSTEM_NAME MATCHES "Windows")
    SET(PYTHON_SUFFIX ".pyd")
  ELSEIF(UNIX)
    # Python modules must end .so under Mac 
    SET(PYTHON_SUFFIX ".so")
  ENDIF()
  
  IF (APPLE)

      ADD_LIBRARY(StOptGrids  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGrids.cpp)
      TARGET_LINK_LIBRARIES(StOptGrids  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} )
      SET_TARGET_PROPERTIES(StOptGrids  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptReg  SHARED  ${SOURCE_PYTHON}/Pybind11StOptReg.cpp)
      TARGET_LINK_LIBRARIES(StOptReg  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} )
      SET_TARGET_PROPERTIES(StOptReg  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION"  LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptTree  SHARED  ${SOURCE_PYTHON}/Pybind11StOptTree.cpp)
      TARGET_LINK_LIBRARIES(StOptTree  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} )
      SET_TARGET_PROPERTIES(StOptTree  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptGeners  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGeners.cpp)
      TARGET_LINK_LIBRARIES(StOptGeners  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY})
      SET_TARGET_PROPERTIES(StOptGeners  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptGlobal  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGlobal.cpp)
      TARGET_LINK_LIBRARIES(StOptGlobal  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY})
      SET_TARGET_PROPERTIES(StOptGlobal  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptCDF  SHARED  ${SOURCE_PYTHON}/Pybind11StOptCDF.cpp)
      TARGET_LINK_LIBRARIES(StOptCDF  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY})
      SET_TARGET_PROPERTIES(StOptCDF  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")
  
    ELSE()
      
      ADD_LIBRARY(StOptGrids  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGrids.cpp)
      TARGET_LINK_LIBRARIES(StOptGrids  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} ${Python_LIBRARIES})
      SET_TARGET_PROPERTIES(StOptGrids  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION")

      ADD_LIBRARY(StOptReg  SHARED  ${SOURCE_PYTHON}/Pybind11StOptReg.cpp)
      TARGET_LINK_LIBRARIES(StOptReg  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} ${Python_LIBRARIES})
      SET_TARGET_PROPERTIES(StOptReg  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION")

=== debian/changelog ===
stopt (5.12+dfsg-2build1) oracular; urgency=medium

  * No-change rebuild against mpi-defaults 1.17

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Thu, 01 Aug 2024 09:36:52 -0700

stopt (5.12+dfsg-2) unstable; urgency=medium

  * B-D on mpi-default-dev so that MPICH is chosen on 32-bit arches
  * Letting the --oversubscribe mpiexec flag be written by d/rules, as MPICH
    won't understand this

 -- Pierre Gruet <pgt@debian.org>  Thu, 25 Jul 2024 07:10:49 +0200

stopt (5.12+dfsg-1) unstable; urgency=medium

  * New upstream version 5.12+dfsg
  * Refreshing patches
  * Raising Standards version to 4.7.0 (no change)
  * Updating d/watch after the change in the layout of Gitlab
  * Removing redundant build-dependency on dpkg-dev

 -- Pierre Gruet <pgt@debian.org>  Wed, 24 Jul 2024 08:57:40 +0200

=== debian/control ===
Source: stopt
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Pierre Gruet <pgt@debian.org>,
           Xavier Warin <xavier.warin@gmail.com>
Section: math
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               dh-python,
Build-Depends-Arch: cmake,
                    coinor-libcoinutils-dev,
                    coinor-libosi-dev,
                    coinor-libclp-dev,
                    libboost-chrono-dev,
                    libboost-log-dev,
                    libboost-mpi-dev,
                    libboost-random-dev,
                    libboost-serialization-dev,
                    libboost-system-dev,
                    libboost-test-dev,
                    libboost-thread-dev,
                    libboost-timer-dev,
                    libeigen3-dev,
                    libgeners-dev,
                    mpi-default-dev,
                    pybind11-dev,
                    python3-dev,
                    python3-docutils,
                    python3-numpy
Build-Depends-Indep: texlive-fonts-extra <!nodoc>,
                     texlive-latex-recommended <!nodoc>,
                     texlive-plain-generic <!nodoc>,
                     texlive-pstricks <!nodoc>,
                     texlive-science <!nodoc>
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/math-team/stopt
Vcs-Git: https://salsa.debian.org/math-team/stopt.git
Homepage: https://gitlab.com/stochastic-control/StOpt/
Rules-Requires-Root: no

Package: libstopt5t64
Provides: ${t64:Provides}
Replaces: libstopt5
Breaks: libstopt5 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: stopt-doc (= ${binary:Version})
Description: library for stochastic optimization problems (shared library)
 The STochastic OPTimization library (StOpt) aims at providing tools in C++ for
 solving some stochastic optimization problems encountered in finance or in the
 industry. Different methods are available:
  - dynamic programming methods based on Monte Carlo with regressions (global,
  local, kernel and sparse regressors), for underlying states following some
  uncontrolled Stochastic Differential Equations;
  - dynamic programming with a representation of uncertainties with a tree:
  transition problems are here solved by some discretizations of the commands,
  resolution of LP with cut representation of the Bellman values;
  - Semi-Lagrangian methods for Hamilton Jacobi Bellman general equations for
  underlying states following some controlled Stochastic Differential
  Equations;
  - Stochastic Dual Dynamic Programming methods to deal with stochastic stock
  management problems in high dimension. Uncertainties can be given by Monte
  Carlo and can be represented by a state with a finite number of values
  (tree);
  - Some branching nesting methods to solve very high dimensional non linear
  PDEs and some appearing in HJB problems. Besides some methods are provided
  to solve by Monte Carlo some problems where the underlying stochastic state
  is controlled.
  For each method, a framework is provided to optimize the problem and then
  simulate it out of the sample using the optimal commands previously computed.
  Parallelization methods based on OpenMP and MPI are provided in this
  framework permitting to solve high dimensional problems on clusters.
 The library should be flexible enough to be used at different levels depending
 on the user's willingness.
 .
 This package contains the shared libraries: one which allows for
 multithreading (libstopt-mpi) and one which does not (libstopt).

Package: libstopt-dev
Architecture: any
Section: libdevel
Depends: libstopt5t64 (= ${binary:Version}),
         coinor-libcoinutils-dev,
         coinor-libosi-dev,
         coinor-libclp-dev,
         libboost-chrono-dev,
         libboost-log-dev,
         libboost-mpi-dev,
         libboost-random-dev,
         libboost-serialization-dev,
         libboost-system-dev,
         libboost-test-dev,
         libboost-thread-dev,
         libboost-timer-dev,
         libeigen3-dev,
         libgeners-dev,
         libopenmpi-dev,
         ${misc:Depends}
Suggests: stopt-doc (= ${binary:Version})
Description: library for stochastic optimization problems (development package)
 The STochastic OPTimization library (StOpt) aims at providing tools in C++ for
 solving some stochastic optimization problems encountered in finance or in the
 industry. Different methods are available:
  - dynamic programming methods based on Monte Carlo with regressions (global,
  local, kernel and sparse regressors), for underlying states following some
  uncontrolled Stochastic Differential Equations;
  - dynamic programming with a representation of uncertainties with a tree:
  transition problems are here solved by some discretizations of the commands,
  resolution of LP with cut representation of the Bellman values;
  - Semi-Lagrangian methods for Hamilton Jacobi Bellman general equations for
  underlying states following some controlled Stochastic Differential
  Equations;
  - Stochastic Dual Dynamic Programming methods to deal with stochastic stock
  management problems in high dimension. Uncertainties can be given by Monte
  Carlo and can be represented by a state with a finite number of values
  (tree);
  - Some branching nesting methods to solve very high dimensional non linear
  PDEs and some appearing in HJB problems. Besides some methods are provided
  to solve by Monte Carlo some problems where the underlying stochastic state
  is controlled.
  For each method, a framework is provided to optimize the problem and then
  simulate it out of the sample using the optimal commands previously computed.
  Parallelization methods based on OpenMP and MPI are provided in this
  framework permitting to solve high dimensional problems on clusters.
 The library should be flexible enough to be used at different levels depending
 on the user's willingness.
 .
 This package contains the headers and the static libraries (libstopt-mpi
 which allows for multithreading, and libstopt which does not).

Package: stopt-examples
Architecture: all
Depends: ${misc:Depends}
Suggests: g++,
          libstopt-dev,
          python3-numpy,
          python3-stopt
Enhances: libstopt-dev,
          python3-stopt
Multi-Arch: foreign
Description: library for stochastic optimization problems (programs examples)
 This package provides some programs written to solve mathematical problems
 using the StOpt library. The source code is provided, examples are available
 in C++ and in Python. C++ source code has to be built against the libstopt-dev
 package if one wants to run it.

Package: python3-stopt
Architecture: any
Section: python
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Provides: ${python3:Provides}
Description: library for stochastic optimization problems (Python 3 bindings)
 The STochastic OPTimization library (StOpt) aims at providing tools in C++ for
 solving some stochastic optimization problems encountered in finance or in the
 industry. Python 3 bindings are provided by this package in order to allow one
 to use the C++ library in a Python code.

Package: stopt-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libstopt5t64 (= ${binary:Version}),
          libstopt-dev (= ${binary:Version}),
          stopt-examples (= ${binary:Version}),
          python3-stopt (= ${binary:Version})
Multi-Arch: foreign
Description: library for stochastic optimization problems (documentation)
 The STochastic OPTimization library (StOpt) aims at providing tools in C++ for
 solving some stochastic optimization problems encountered in finance or in the
 industry. Python 3 bindings are also provided in order to allow one to use the
 C++ library in a Python code.
 .
 This package contains the documentation about the type of problems that can be
 solved, the mathematical framework, its implementation, and the examples.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# If noopt was not passed, building with -O3 instead of -O2 to enhance
# numerical performance.
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
export DEB_CXXFLAGS_MAINT_APPEND=-O3
export DEB_CXXFLAGS_MAINT_STRIP=-O2
endif

include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)
DPKG_EXPORT_BUILDFLAGS = 1
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

include /usr/share/dpkg/pkg-info.mk

PY3VER=$(shell py3versions -d)

SOVERSION_STOPT=5
VERSION_STOPT=$(shell echo $(DEB_VERSION_UPSTREAM) | sed -E 's/~rc[0-9]*// ; s/\+dfsg[0-9]*//')

# Using --oversubscribe if Open MPI is used, and no flag for MPICH.
ifeq (, $(shell dpkg --list | grep "libmpich-dev"))
OVERSUBSCRIBE_FLAG=--oversubscribe
else
OVERSUBSCRIBE_FLAG=
endif

%:
	dh $@ --with python3

override_dh_auto_clean:
	dh_auto_clean
	# Removing the build directory of the LaTeX documentation.
	-rm -rf texdocBuild/

override_dh_auto_configure-arch:
	dh_auto_configure -- \
	        -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
	        -DCMAKE_INSTALL_PREFIX="/usr" \
	        -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	        -DSOVERSION_STOPT="$(SOVERSION_STOPT)" \
	        -DVERSION_STOPT="$(VERSION_STOPT)" \
	        -DPython3_INCLUDE_DIRS=$(shell python3-config --includes | sed 's/.*-I//') \
	        -DPython3_LIBRARIES=$(shell ls /usr/lib/$(DEB_HOST_MULTIARCH)/libpython*.so | grep "$(PY3VER)") \
	        -DPython3_NumPy_INCLUDE_DIRS=/usr/lib/python3/dist-packages/numpy/core/include \
	        -DMPIEXEC_PREFLAGS=$(OVERSUBSCRIBE_FLAG)

override_dh_auto_configure-indep:

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	# Building the LaTeX documentation.
	# Two sets of paths have to be changed because we used a MUT package.
	cp -a texdoc/ texdocBuild/
	cd texdocBuild && \
	        sed -i 's|../StOpt/StOpt/|../StOpt/|g' documentation.tex && \
	        sed -i 's|../StOpt/test/|../test/|g' documentation.tex && \
	        pdflatex documentation.tex && \
	        bibtex documentation.aux && \
	        pdflatex documentation.tex && \
	        pdflatex documentation.tex
endif

# Tests cannot be run safely in parallel.
override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test -a --no-parallel
endif

# No test to perform for the architecture-independent packages
override_dh_auto_test-indep:

override_dh_installdocs-indep:
	dh_installdocs -i
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	mkdir -p debian/stopt-doc/usr/share/doc/stopt-doc/
	cp texdocBuild/documentation.pdf debian/stopt-doc/usr/share/doc/stopt-doc/
endif

override_dh_installexamples-indep:
	dh_installexamples -i
	cp -a test/python/ debian/stopt-examples/usr/share/doc/stopt-examples/examples/
	# Some Python tests cannot be run because we don't package all built .so...
	# some of them being designed for the tests only.
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/functional/
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/unit/geners/testSomeBinaryArchiveStorage.py
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/unit/global
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/unit/sddp
	rm -rf debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/unit/tree

override_dh_fixperms-indep:
	dh_fixperms -i
	#Setting all Python scripts (that are shipped as examples) as being executable
	for F in $$(find debian/stopt-examples/usr/share/doc/stopt-examples/examples/python/ -name "test*.py"); do \
	        chmod a+x $$F; \
	done

## stopt 5.15+dfsg

=== debian/changelog ===
stopt (5.15+dfsg-1) experimental; urgency=medium

  * New upstream version 5.15+dfsg
  * Refreshing patches
  * Raising Standards version to 4.7.2 (no change)

 -- Pierre Gruet <pgt@debian.org>  Fri, 11 Jul 2025 15:20:24 +0200

stopt (5.12+dfsg-3) unstable; urgency=medium

  * Having the -dev package depend on mpi-default-dev so that MPICH is chosen
    on 32-bit arches (Closes: #1087962)
  * Skipping the build with mpi until stopt can be built with openmpi 5.x
    (Closes: #1086385)

 -- Pierre Gruet <pgt@debian.org>  Thu, 05 Dec 2024 09:39:41 +0100

## stopt 5.16%2Bdfsg

=== debian/watch ===
version=4

opts="searchmode=plain,dversionmangle=s/\+dfsg\d*//,oversionmangle=s/(.*)/$1+dfsg/" \
  https://gitlab.com/stochastic-control/StOpt/tags?sort=updated_desc \
  -/archive/v?\d[\d.]+/StOpt-v@ANY_VERSION@\.tar\.gz debian

opts="component=texdoc,searchmode=plain" \
  https://gitlab.com/stochastic-control/StOptDoc/tags?sort=updated_desc \
  -/archive/v?\d[\d.]+/StOptDoc-v@ANY_VERSION@\.tar\.gz \
  ignore

## stopt 5.16+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -49,7 +49,6 @@
 ENDIF(BUILD_LONG_TEST)
 
 # Boost
-ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
 IF(BUILD_TEST)
   FIND_PACKAGE(Boost COMPONENTS unit_test_framework  system  timer chrono log thread  REQUIRED)
 ENDIF()
@@ -117,7 +116,7 @@
   IF(MSVC_VERSION LESS 1800)
     MESSAGE(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no decent C++11 support. Please use a different C++ compiler.")
   ENDIF()
-  ADD_COMPILE_OPTIONS(/bigobj)
+  ADD_COMPILE_OPTIONS(/bigobj /EHsc)
 ENDIF(NOT MSVC)
 
 # Update flags according to the compiler

=== R/StOptRegression/DESCRIPTION ===
Package: StOptRegression
Type: Package
Title: What the Package Does in One 'Title Case' Line
Version: 1.0
Date: 2017-02-08
Author: Your Name
Maintainer: Your Name <your@email.com>
Description: One paragraph description of what the package does as one
        or more full sentences.
License: GPL (>= 2)
Imports: methods, Rcpp (>= 0.12.9)
LinkingTo: Rcpp, RcppEigen
RoxygenNote: 6.0.1

=== debian/changelog ===
stopt (5.16+dfsg-2) unstable; urgency=medium

  * Deactivating part of a test which started failing with gcc-15
    (Closes: 1097940)

 -- Pierre Gruet <pgt@debian.org>  Sat, 06 Sep 2025 07:14:23 +0200

stopt (5.16+dfsg-1) unstable; urgency=medium

  * New upstream version 5.16+dfsg
  * Refreshing patches

 -- Pierre Gruet <pgt@debian.org>  Sun, 17 Aug 2025 19:15:18 +0200

=== debian/rules ===
--- 
+++ 
@@ -38,9 +38,12 @@
 	-rm -rf texdocBuild/
 
 override_dh_auto_configure-arch:
+	# Skipping the build with mpi with BUILD_MPI=OFF until stopt can be built
+	# against openmpi 5.x
 	dh_auto_configure -- \
 	        -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
 	        -DCMAKE_INSTALL_PREFIX="/usr" \
+	        -DBUILD_MPI=OFF \
 	        -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
 	        -DSOVERSION_STOPT="$(SOVERSION_STOPT)" \
 	        -DVERSION_STOPT="$(VERSION_STOPT)" \

=== debian/tests/control ===
Tests: someCppUnitTests
Depends: libstopt-dev, stopt-examples, g++
Restrictions: allow-stderr

Tests: pythonUnitTests
Depends: stopt-examples, python3-stopt, python3-numpy

## stopt 6.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -86,8 +86,14 @@
 ENDIF(WIN32)
 
 #Eigen
-FIND_PACKAGE(Eigen3 REQUIRED)
+FIND_PACKAGE(Eigen3  3.4 REQUIRED )
 INCLUDE_DIRECTORIES(SYSTEM ${EIGEN3_INCLUDE_DIR})
+IF (EIGEN3_FOUND)
+  MESSAGE(STATUS "Eigen  ${EIGEN3_VERSION} found")
+ELSE()
+  MESSAGE(STATUS "Correct version of Eigen not found") 
+ENDIF(EIGEN3_FOUND)
+
 # Add some extra delete[] and new[] operatros needed by boost to Eigen::PlainObjectBase
 IF (APPLE)
   ADD_DEFINITIONS(-DEIGEN_PLAINOBJECTBASE_PLUGIN="StOpt/core/utils/eigenMemory.h")
@@ -209,7 +215,7 @@
 IF(BUILD_PYTHON)
     
   # Python
-  FIND_PACKAGE(Python REQUIRED COMPONENTS Interpreter Development NumPy)
+  FIND_PACKAGE(Python REQUIRED COMPONENTS Interpreter Development)
   INCLUDE_DIRECTORIES(SYSTEM ${Python_INCLUDE_DIRS})
   MESSAGE(STATUS "Python: ${Python_INCLUDE_DIRS}")
 
@@ -260,5 +266,3 @@
 
       ADD_LIBRARY(StOptReg  SHARED  ${SOURCE_PYTHON}/Pybind11StOptReg.cpp)
       TARGET_LINK_LIBRARIES(StOptReg  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} ${Python_LIBRARIES})
-      SET_TARGET_PROPERTIES(StOptReg  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION")
-

=== debian/changelog ===
stopt (6.1+dfsg-1) unstable; urgency=medium

  * New upstream version 6.1+dfsg
  * Refreshing patches
  * Bumping copyright years
  * Rewriting d/watch with version 5

 -- Pierre Gruet <pgt@debian.org>  Fri, 14 Nov 2025 13:10:51 +0100

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,7 @@
                      texlive-plain-generic <!nodoc>,
                      texlive-pstricks <!nodoc>,
                      texlive-science <!nodoc>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/math-team/stopt
 Vcs-Git: https://salsa.debian.org/math-team/stopt.git
 Homepage: https://gitlab.com/stochastic-control/StOpt/
@@ -95,7 +95,7 @@
          libboost-timer-dev,
          libeigen3-dev,
          libgeners-dev,
-         libopenmpi-dev,
+         mpi-default-dev,
          ${misc:Depends}
 Suggests: stopt-doc (= ${binary:Version})
 Description: library for stochastic optimization problems (development package)

=== debian/watch ===
Version: 5

Source: https://gitlab.com/stochastic-control/StOpt/tags?sort=updated_desc
Matching-Pattern: -/archive/v?\d[\d.]+/StOpt-v@ANY_VERSION@\.tar\.gz
Dversionmangle: s/\+dfsg\d*//
Oversionmangle: s/(.*)/$1+dfsg/
Searchmode: plain

Component: texdoc
Source: https://gitlab.com/stochastic-control/StOptDoc/tags?sort=updated_desc
Matching-Pattern: -/archive/v?\d[\d.]+/StOptDoc-v@ANY_VERSION@\.tar\.gz
Searchmode: plain
Version-Schema: ignore
